% Rechte Seite
f = @(t,y) y;

% Exakte Loesung
yN_exact = exp(2.);
y0       = 1;
t0       = 0;
T        = 2;

% Vektor mit Anzahl der verwendeten Schritte
N = 2.^([0:8]);

% ZeitSchrittweite
h = 2./N;

% Alloziere Speicherplatz
yN_approx_4 = zeros(size(N));
yN_approx_5 = zeros(size(N));

% Bestimme eine Approximation mit N(XX) Schritten
for ii = 1:length(N)
    [tRK4, yN_approx_4_loc] = RKF45(f,y0,t0,T,h(ii),1e-5,1e-5,2);
    [tRK5, yN_approx_5_loc] = RKF45(f,y0,t0,T,h(ii),1e-5,1e-5,1);
    yN_approx_4(ii)         = yN_approx_4_loc(end);
    yN_approx_5(ii)         = yN_approx_5_loc(end);
end

% Absoluter Fehler
err_4 = abs(yN_approx_4 - yN_exact);
err_5 = abs(yN_approx_5 - yN_exact);

figure;
loglog(h,err_4,'*-');
hold on
loglog(h,err_5,'o-');
grid on;
xlabel('Schrittweite h')
ylabel('Abs Fehler')

% Steigung
fit_4 = polyfit(log(h(end-3:end)),log(err_4(end-3:end)),1);
fit_5 = polyfit(log(h(end-3:end)),log(err_5(end-3:end)),1);
fprintf('Konvergenzrate RK 4 = %1.2f\n',fit_4(1));
fprintf('Konvergenzrate RK 5 = %1.2f\n',fit_5(1));
